/*-------------------------------------------------------------------------*/
/*                                                                         */
/*    Turbo Vision Resource WorkShop                                       */
/*    TVRW Demonstration                                                   */
/*                                                                         */
/*    Copyright (c) 1993  by Siskiyou Software                             */
/*                                                                         */
/*-------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------*/
/*                                                                         */
/*    Compile this program with:                                           */
/*  bcc -ml demo.cpp rgetdlg.obj c:\bc31\tvision\demos\gadgets.cpp tv.lib  */
/*                                                                         */
/*-------------------------------------------------------------------------*/

#define Uses_TStaticText
#define Uses_TApplication
#define Uses_TEventQueue
#define Uses_TKeys
#define Uses_TMenuBar
#define Uses_TSubMenu
#define Uses_TMenuItem
#define Uses_TStatusLine
#define Uses_TStatusItem
#define Uses_TStatusDef
#define Uses_TDeskTop
#define Uses_TMenu
#define Uses_TDialog
#define Uses_TButton
#define Uses_MsgBox
#define Uses_THeapView
#include <tv.h>

#include "c:\bc31\tvision\demos\gadgets.h"    //for the heap view
#include <string.h>                           //for strcpy()

//
//include header files created by tvrw
//
#include "clientin.h"         //client info header file
#include "notebook.h"         //notebook header file
#include "algorith.h"         //algorithm header file

//
//define command constants
//
const int cmAbout      = 100;
const int cmNoteBook   = 101;
const int cmClientInfo = 102;
const int cmAlgorithms = 103;


class TMyApp : public TApplication
{
  struct notebook   noteBook;            //instantiate a note book structure
  struct clientinfo clientInfo;          //instantiate a client info structure
  struct algorithms algo;                //instantiate a algorithms structure

  ushort retVal;                         //return value of execView
  THeapView *heap;

public:
	TMyApp();
	static TMenuBar *initMenuBar( TRect );
	static TStatusLine *initStatusLine( TRect );
	void handleEvent(TEvent& event);
	void About(void);
	void TestDialog();
  void idle();

};

TMyApp::TMyApp() :
  TProgInit( initStatusLine,
       initMenuBar,
       initDeskTop
		 )
{
    //
    //Create the heap view
    //
    TRect r = getExtent();
    r.a.x = r.b.x - 13;
    r.a.y = r.b.y - 1;
    heap = new THeapView( r );
    insert(heap);
    //
    // Initialize the fields of the notebook structure
    //
    strcpy( noteBook.memoBuf1, "" );    //null string
    noteBook.memoLen1 = 0;              //length of 0

    //
    // Initialize the fields of the clientInfo structure
    //
    strcpy( clientInfo.memoBuf1, "" );
    clientInfo.memoLen1 = 0;
    strcpy( clientInfo.inputLine1, "" );
    strcpy( clientInfo.inputLine2, "" );
    strcpy( clientInfo.inputLine3, "" );
    strcpy( clientInfo.inputLine4, "" );

    //
    // Initialize the fields of Algorithms structure
    //
    algo.radio1 = algo.radio2 = algo.check1 = 0;


}

void TMyApp::idle()
{
   TProgram::idle();
   if( heap !=  0 )
     heap->update();
}

void TMyApp::handleEvent(TEvent& event)
{

   TApplication::handleEvent( event );

   if( event.what == evCommand )
   {
      switch( event.message.command)
      {
        case cmAbout:
          TDialog *pd = RGetDialog("demo.rez", "about" );
          if( validView( pd ) )
          {
             deskTop->execView( pd );
             destroy( pd );
          }
          break;

        case cmNoteBook:
          TDialog *od = RGetDialog("demo.rez", "notebook" );
          if( validView( od ) )
          {
             od->setData( &noteBook );
             retVal =  deskTop->execView( od );
             if( retVal == cmOK )
             {
                od->getData( &noteBook );
                //do something with input here...
             }
             destroy( od );
          }
          break;

        case cmClientInfo:
          TDialog *ci = RGetDialog("demo.rez", "clientinfo" );
          if( validView( ci ) )
          {
             ci->setData( &clientInfo );
             retVal =  deskTop->execView( ci );
             if( retVal == cmOK )
             {
                ci->getData( &clientInfo );
                //save client info to file here...
             }
             destroy( ci );
          }
          break;

        case cmAlgorithms:
          TDialog *al = RGetDialog("demo.rez", "algorithms" );
          if( validView( al ) )
          {
             al->setData( &algo );
             retVal =  deskTop->execView( al );
             if( retVal == cmOK )
             {
                al->getData( &algo );
                //take some action based on algorithm
             }
             destroy( al );
          }
          break;

        default:
          break;
      }

      clearEvent( event );
   }
}


TStatusLine *TMyApp::initStatusLine(TRect r)
{
   r.a.y = r.b.y - 1;

   return new TStatusLine( r,
       *new TStatusDef( 0, 0xFFFF) +
       *new TStatusItem( "~Alt+X~ Exit", kbAltX, cmQuit) +
       *new TStatusItem( "~Alt+A~ About", kbAltA, cmAbout)
       );
}


TMenuBar *TMyApp::initMenuBar( TRect r )
{
    r.b.y = r.a.y + 1;

   TMenuBar *pd = new TMenuBar( r,
      *new TSubMenu("~\xF0~", kbAltSpace, hcNoContext) +
        *new TMenuItem("~A~bout", cmAbout, kbAltA,
                        hcNoContext, 0) +
        *new TMenuItem("E~x~it", cmQuit, kbAltX,
                        hcNoContext, 0) +

     *new TSubMenu("~C~lients", kbAltC, hcNoContext) +
       *new TMenuItem("~N~ote Book", cmNoteBook, kbAltN,
                       hcNoContext, "Alt+N") +

       *new TMenuItem("Client ~I~nfo", cmClientInfo, kbAltI,
                       hcNoContext, "Alt+I")+

       *new TMenuItem("~A~lgorithms", cmAlgorithms, kbAltA,
                       hcNoContext, "Alt+A") );
   return pd;


}


int main()
{

	TMyApp myApp;
	myApp.run();
	return 0;
}
